//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "ITSLangTransF.h"
#include "ITSMapF.h"
#include "WindowMsgF.h"
#pragma hdrstop

#include "WCAM100MF.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxGroupBox"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxSpinEdit"
#pragma link "cxSplitter"
#pragma link "cxTextEdit"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "FRAME_OpenMapF"
#pragma link "FRAME_WCamListF"
#pragma resource "*.dfm"

TWCAM100M *WCAM100M = NULL;
//---------------------------------------------------------------------------
void TWCAM100M_MapCallback(TObject *ASender, const String AFunc, const String AArgs, const bool AFirst)
{
    try
    {
        if (!WCAM100M) return;
        WCAM100M->OpenMapCallback(ASender, AFunc, AArgs, AFirst);
    }
    catch(Exception &exception)
    {
    }
}
//---------------------------------------------------------------------------

__fastcall TWCAM100M::TWCAM100M(TComponent* Owner)
    : TForm(Owner)
{
    LangTrans->Translate(this, ITSDb_GetConnection());
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FUpdate= false;
    FTitle = Caption;//"웹카메라 기본정보 관리";

    FRAMEWCamList1->PnlTop->Visible = false;
    FRAMEWCamList1->PnlBottom->Visible = false;
    FRAMEWCamList1->ColumnSel->Visible = false;

    m_pGDC = FRAMEWCamList1->TvList->DataController;

    FLayerIdx = LyrTp_WCam;
    FRAMEOpenMap1->LayerIdx = FLayerIdx;
    FRAMEOpenMap1->MapCallbackFunc = TWCAM100M_MapCallback;

    EditMode = false;
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::CommClose()
{
    try
    {
        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::FormShow(TObject *Sender)
{
    Refresh();

    FRAMEOpenMap1->OpenMap();

    APP_FillCode(CbType, "CTVT");

    WCamCtlrManager->FLists.Lock();
    try
    {
        FOR_STL(TWCamCtlr*, pObj, WCamCtlrManager->FLists)
        {
            if (pObj->DEL_YN == "Y") continue;
            pObj->FData3 = NULL;
        }
    }
    __finally
    {
        WCamCtlrManager->FLists.UnLock();
    }

    FormInit();
    ChangeEditMode(1);
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::FormInit()
{
	EdNmbr->Text = "";
    EdWCamId->Text = "";
	EdWCamNm->Text = "";
    ISTL_LCTN_NM->Text = "";
    ISTL_LCTN_ADDR->Text = "";

	//CbUsagType->ItemIndex = 0;
	CbType->ItemIndex = 0;

    SePosX->Value = 0;
    SePosY->Value = 0;

    EdCtlrIp->Text = "";
    EdCmncPort->Text = "";

    Ed_WCAM_IP->Text = "";
    Ed_CMRA_PORT->Text = "";
    Ed_CMRA_ID->Text = "";
    Ed_CMRA_PSWD->Text = "";
    Se_CMRA_CHNL->Value = 1;

    Ed_STRM_SVR_IP->Text = "";
    Ed_STRM_RTSP_ADDR->Text = "";
    Ed_STRM_RTMP_ADDR->Text = "";
	Ed_STRM_HTTP_ADDR->Text = "";

    FNewDb = false;
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;
    FRAMEWCamList1->UpdateList();
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::BtnCloseClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    WCAM100M = NULL;
    Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if (FUpdate)
    {
        POST_MSG(Application->MainForm->Handle, WM_DATABASE_REFRESH, WP_MSG_14, 0);
    }

    FRAMEWCamList1->OnCloseQuery(CanClose);
    FRAMEOpenMap1->OnCloseQuery(CanClose);
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::DisplayInfo(TWCamCtlr* AObj, bool AMoveObj/*=true*/)
{
    FormInit();

    if (!AObj) return;

    if (AMoveObj)
    {
        sJs.printf(L"selectLayerObject(%d, '%s', %d)", FLayerIdx, AObj->WCAM_CTLR_NMBR.c_str(), FRAMEOpenMap1->MapZoom);
        FRAMEOpenMap1->ExecScript(sJs);
    }
	EdNmbr->Text  = String(AObj->WCAM_CTLR_NMBR);
    EdWCamId->Text = AObj->WCAM_CTLR_ID;
	EdWCamNm->Text = AObj->WCAM_NM;
    ISTL_LCTN_NM->Text = AObj->ISTL_LCTN_NM;
    ISTL_LCTN_ADDR->Text = AObj->ISTL_LCTN_ADDR;

	APP_SetCode(CbType, AObj->WCAM_TYPE_CD);

    SePosX->Value = AObj->X_CRDN;
    SePosY->Value = AObj->Y_CRDN;

    EdCtlrIp->Text = AObj->WCAM_CTLR_IP;
    //EdCmncPort->Text = AObj->WCAM_CTLR_PORT;

    //Ed_WCAM_IP->Text = AObj->CCTV_IP;
    Ed_CMRA_PORT->Text = AObj->CMRA_PORT;
    Ed_CMRA_ID->Text = AObj->CMRA_ID;
    Ed_CMRA_PSWD->Text = AObj->CMRA_PSWD;
    Se_CMRA_CHNL->Value = AObj->CMRA_CHNL;

    Ed_STRM_SVR_IP->Text = AObj->STRM_SVR_IP;
    Ed_STRM_RTSP_ADDR->Text = AObj->STRM_RTSP_ADDR;
    Ed_STRM_RTMP_ADDR->Text = AObj->STRM_RTMP_ADDR;
	Ed_STRM_HTTP_ADDR->Text = AObj->STRM_HTTP_ADDR;
    Ed_STRM_SESN_NM->Text   = AObj->STRM_SESN_NM;

//    FRAMEGisMap1->SelectObjectByPos(SePosX->Value, SePosY->Value, true);

    ChangeEditMode(3);
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::UpdateIcon()
{
    if (!FRAMEOpenMap1->MapStart) return;

    sJs.printf(L"removeLayerObject(%d)", FLayerIdx);
    FRAMEOpenMap1->ExecScript(sJs);

    String arrObj = "";
    String sTemp;

    WCamCtlrManager->FLists.Lock();
    try
    {
        FOR_STL(TWCamCtlr*, pObj, WCamCtlrManager->FLists)
        {
            if (pObj->DEL_YN == "Y") continue;

            if (arrObj != "") arrObj += "|";

            sTemp.printf(L"%s,%s,%s,%.6f,%.6f,0,0,0,0", pObj->WCAM_CTLR_NMBR.c_str(), pObj->WCAM_CTLR_ID.c_str(), pObj->WCAM_NM.c_str(), pObj->X_CRDN, pObj->Y_CRDN);
            arrObj += sTemp;
        }
    }
    __finally
    {
        WCamCtlrManager->FLists.UnLock();
        if (arrObj != "")
        {
            sJs.printf(L"addFacility(%d, '%s')", FLayerIdx, arrObj.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::BtnEditClick(TObject *Sender)
{
    String sId = EdNmbr->Text;
    TWCamCtlr *pObj = WCamCtlrManager->FLists.Find(sId);

    FNewDb = false;

    if (BtnEdit->Caption == FrmLang->lblEdit->Caption)//"편집")
    {
        //편집모드 시작
        ChangeEditMode(0);
        if (pObj)
        {
            //시설물아이콘을 편집아이콘으로 변경
            //function editFacilityObject(ALyrIdx, ANmbr, AComm(0:오류-편집,1:정상), AEdit(편집모드:1-편집,0-편집취소))
            sJs.printf(L"editFacilityObject(%d, %s, 1, 1)", FLayerIdx, pObj->WCAM_CTLR_NMBR.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
    else
    {
        //편집모드 취소
        ChangeEditMode(1);
        if (pObj)
        {
            //원래 정보를 화면에 표출
            CMM_SetGridRow(FRAMEWCamList1->CxList, FRAMEWCamList1->TvList, sId, FRAMEWCamList1->Column01->Index);
            DisplayInfo(pObj, false);

#if 0
            //지도시설물아이콘을 원래아이콘으로 변경
            sJs.printf(L"editFacilityObject(%d, %s, 0, 0)", FLayerIdx, pObj->WCAM_CTLR_NMBR.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
#else
            //추가 모드에서 취소하는 경우 지도에 신규로 추가한 객체를 찾아서 삭제해 주는것 보다
            //새롭게 다시 그리자
            UpdateIcon();
#endif
        }
        else
        {
            //객체가 없는 경우는 추가 모드에서 취소한 경우임
            sJs.printf(L"removeFacilityObject(%d, %s)", FLayerIdx, sId.c_str());
            FRAMEOpenMap1->ExecScript(sJs);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::ChangeEditMode(int AEdit)
{
    bool bEnabled = false;
    switch(AEdit)
    {
    case 0: //편집버튼클릭
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = FrmLang->lblCancel->Caption;//"취소";
            BtnEdit->Hint    = FrmLang->lblCancel->Hint;//데이터 편집 취소";
            EditMode = true;
        }
        break;
    case 1: //편집[취소]버튼클릭
        {
            FormInit(); //화면을 모두 지운다.
            BtnEdit->Enabled = false;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = false;

            BtnEdit->Caption = FrmLang->lblEdit->Caption;//"편집";
            BtnEdit->Hint    = FrmLang->lblEdit->Hint;//데이터 편집";
            //bEnabled = true;
            EditMode = false;
        }
        break;
    case 2: //추가
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = FrmLang->lblCancel->Caption;//"취소";
            BtnEdit->Hint    = FrmLang->lblCancel->Hint;//데이터 편집 취소";
            EditMode = true;
        }
        break;
    case 3: //수정모드
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = true;
            BtnSave->Enabled = false;

            BtnEdit->Caption = FrmLang->lblEdit->Caption;//"편집";
            BtnEdit->Hint    = FrmLang->lblEdit->Hint;//데이터 편집";
            bEnabled = true;
            EditMode = false;
        }
        break;
    }

    if (AEdit == 0 || AEdit == 2)
    {
        FRAMEWCamList1->CxList->Enabled = false;
    }
    else
    {
        FRAMEWCamList1->CxList->Enabled = true;
    }

    PnlEdit->Enabled = EditMode;
}
//---------------------------------------------------------------------------


void __fastcall TWCAM100M::BtnInsertClick(TObject *Sender)
{
    FormInit();
    //신규아이디를 얻어와서 화면을 초기화한다.

    int nNmbr, nId;
    if (!WCamCtlrManager->GetNextWCamId(nNmbr, nId))
    {
        Application->MessageBox(lblText1->Caption.c_str(),//L"새로운 웹카메라 정보를 생성하지 못하였습니다.\r\n프로그램 종료후에 다시 시도해 보세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }

    EdNmbr->Text = String(nNmbr);
    SePosX->Value = FRAMEOpenMap1->CenterX;
    SePosY->Value = FRAMEOpenMap1->CenterY;

    //지도에 새로운 시설물 아이콘 추가하면서 편집모드로 변경
    String arrObj = "";
    arrObj.printf(L"%d,New,New,%.6f,%.6f,0", nNmbr, FRAMEOpenMap1->CenterX, FRAMEOpenMap1->CenterY);
    sJs.printf(L"addFacilityObject(%d, '%s')", FLayerIdx, arrObj.c_str());
    FRAMEOpenMap1->ExecScript(sJs);

    ChangeEditMode(2);
    FNewDb = true;
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::BtnDeleteClick(TObject *Sender)
{
    if (!FRAMEOpenMap1->MapStart) return;

    int nIdx = m_pGDC->FocusedRecordIndex;
    if (nIdx < 0) return;

    String sId = EdNmbr->Text;

    if (sId.IsEmpty())
    {
        Application->MessageBox(lblText2->Caption.c_str(),//L"삭제할 웹카메라를 목록에서 선택하세요.\r\n목록에서 더블클릭하여 선택합니다.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }

    String sMsg;
    sMsg = lblText3->Caption + ": " + sId;//"웹카메라번호: " + sId;
    sMsg+= "\r\n" + lblText4->Caption;//"선택하신 웹카메라 정보를 삭제하시겠습니까?";

    if (Application->MessageBox(sMsg.c_str(), FTitle.c_str(), MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) != IDYES) return;

	TWCamCtlr *pObj = WCamCtlrManager->FLists.Find(sId);

	if (pObj)
	{
		if (WCamCtlrManager->DeleteWCam(pObj))
		{
            pObj->DEL_YN = "Y";
            FRAMEWCamList1->UpdateList();
            UpdateIcon();
		}

        FUpdate = true;

        Application->MessageBox(lblText5->Caption.c_str(),//L"웹카메라 정보삭제\r\n웹카메라 정보를 삭제 하였습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

        FormInit();
        ChangeEditMode(1);

        UpdateIcon();
	}
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::BtnSaveClick(TObject *Sender)
{
	if (EdNmbr->Text.IsEmpty()          ||
        EdWCamId->Text.Trim().IsEmpty() ||
        EdWCamNm->Text.Trim().IsEmpty() ||
        SePosX->Value == 0              ||
        SePosY->Value == 0              ||
        CbType->Text.IsEmpty()          ||
        EdCtlrIp->Text.IsEmpty())
	{
        Application->MessageBox(FrmLang->lblNecessary->Caption.c_str(),//L"★항목은 필수 입력 항목입니다.\r\n모두 입력후 진행해 주세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
		return;
	}

    String sNmbr = EdNmbr->Text;
    String sWCamId = EdWCamId->Text.Trim();

    if (!ITSUtil_CheckIpAddress(EdCtlrIp->Text.Trim()))
    {
        Application->MessageBox(lblText6->Caption.c_str(),//L"제어기 IP가 유효하지 않습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
		return;
    }

    if (Ed_WCAM_IP->Text.Trim() != "")
    {
        if (!ITSUtil_CheckIpAddress(Ed_WCAM_IP->Text.Trim()))
        {
            Application->MessageBox(lblText7->Caption.c_str(),//L"웹카메라 IP가 유효하지 않습니다.",
                                    FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
            return;
        }
    }
    if (Ed_STRM_SVR_IP->Text.Trim() != "")
    {
        if (!ITSUtil_CheckIpAddress(Ed_STRM_SVR_IP->Text.Trim()))
        {
            Application->MessageBox(cxLabel14->Caption.c_str(),//L"스트리밍서버 IP가 유효하지 않습니다.",
                                    FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
            return;
        }
    }

    WCamCtlrManager->FLists.Lock();
    FOR_STL(TWCamCtlr*, pTmpObj, WCamCtlrManager->FLists)
    {
        if (pTmpObj->DEL_YN == "Y") continue;
        if (pTmpObj->WCAM_CTLR_NMBR == sNmbr) continue; //자기자신

        if (pTmpObj->WCAM_CTLR_ID == sWCamId)
        {
            Application->MessageBox(lblText8->Caption.c_str(),//L"웹카메라 ID가 이미 사용 중입니다. 웹카메라 ID를 확인하세요.",
                                    FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
            return;
        }
    }
    WCamCtlrManager->FLists.UnLock();

    TWCamCtlr *pObj;
    if (FNewDb)
        pObj = new TWCamCtlr();
    else
        pObj = WCamCtlrManager->FLists.Find(sNmbr);

    if (pObj)
    {
        pObj->WCAM_CTLR_NMBR = sNmbr;
        pObj->WCAM_CTLR_ID   = sWCamId;
        pObj->WCAM_NM        = EdWCamNm->Text.Trim();

        pObj->WCAM_CTLR_IP       = EdCtlrIp->Text;
        pObj->WCAM_CTLR_PORT     = EdCmncPort->Text.ToIntDef(0);
        pObj->WCAM_CTLR_LOCAL_NO = 0;

        pObj->WCAM_TYPE_CD = APP_GetCode(CbType);
        pObj->ISTL_LCTN_NM = ISTL_LCTN_NM->Text.Trim();
        pObj->ISTL_LCTN_ADDR = ISTL_LCTN_ADDR->Text.Trim();

        pObj->X_CRDN = SePosX->Value;
        pObj->Y_CRDN = SePosY->Value;

        //pObj->CCTV_IP   = Ed_CCTV_IP->Text;
        pObj->CMRA_PORT = Ed_CMRA_PORT->Text.ToIntDef(0);
        pObj->CMRA_ID   = Ed_CMRA_ID->Text;
        pObj->CMRA_PSWD = Ed_CMRA_PSWD->Text;
        pObj->CMRA_CHNL = Se_CMRA_CHNL->Value;

        pObj->STRM_SESN_NM  = Ed_STRM_SESN_NM->Text;

        pObj->STRM_SVR_IP    = Ed_STRM_SVR_IP->Text;
        pObj->STRM_RTSP_ADDR = Ed_STRM_RTSP_ADDR->Text;
        pObj->STRM_RTMP_ADDR = Ed_STRM_RTMP_ADDR->Text;
        pObj->STRM_HTTP_ADDR = Ed_STRM_HTTP_ADDR->Text;
        pObj->LINK_ID        = "";

        pObj->Completed    = true;
        pObj->MEM_DEL      = "N";

        bool bResult;
        if (FNewDb)
        {
            pObj->DEL_YN = "N";
            bResult = WCamCtlrManager->InsertWCam(pObj);
            if (bResult)
            {
                WCamCtlrManager->FLists.Push(sNmbr, pObj);
            }
		}
        else
		{
            bResult = WCamCtlrManager->UpdateWCam(pObj);
		}

        if (bResult)
        {
            Application->MessageBox(lblText9->Caption.c_str(),//L"웹카메라 정보저장\r\n웹카메라정 보를 저장 하였습니다.",
                                    FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

            FUpdate = true;

            FRAMEWCamList1->UpdateList();
            UpdateIcon();
            CMM_SetGridRow(FRAMEWCamList1->CxList, FRAMEWCamList1->TvList, sNmbr, FRAMEWCamList1->Column01->Index);
            DisplayInfo(pObj, true);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::FRAMEWCamList1TvListCellDblClick(TcxCustomGridTableView *Sender,
          TcxGridTableDataCellViewInfo *ACellViewInfo, TMouseButton AButton,
          TShiftState AShift, bool &AHandled)
{
	if (!ACellViewInfo) return;
	int nRow = FRAMEWCamList1->TvList->DataController->FocusedRecordIndex;
	if( nRow <= -1 )
		return;

    int nMemPtr = FRAMEWCamList1->TvList->DataController->Values[nRow][FRAMEWCamList1->Column99->Index];
    TWCamCtlr* pObj = (TWCamCtlr*)nMemPtr;
    DisplayInfo(pObj, true);
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::Ed_CMRA_PORTKeyPress(TObject *Sender, wchar_t &Key)
{
    if (Key > '9' || Key < '0')
    {
        if (Key != VK_BACK && Key != VK_TAB && Key != '-')
            Key = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAM100M::Se_CMRA_CHNLPropertiesChange(TObject *Sender)
{
    if (((TcxSpinEdit*)Sender)->Value < ((TcxSpinEdit*)Sender)->Properties->MinValue)
        ((TcxSpinEdit*)Sender)->Value = ((TcxSpinEdit*)Sender)->Properties->MinValue;
    else if(((TcxSpinEdit*)Sender)->Value > ((TcxSpinEdit*)Sender)->Properties->MaxValue &&
        ((TcxSpinEdit*)Sender)->Properties->MaxValue)
        ((TcxSpinEdit*)Sender)->Value = ((TcxSpinEdit*)Sender)->Properties->MaxValue;
}
//---------------------------------------------------------------------------
void __fastcall TWCAM100M::OpenMapCallback(TObject *ASender, const String AFunc, const String AArgs, const bool AFirst)
{
    try
    {
        if (AFirst)
        {
            //지도를 편집모드로 변경
            sJs.printf(L"setEditMode(%d, 1)", FLayerIdx);
            FRAMEOpenMap1->ExecScript(sJs);
            //시설물아이콘 등록
            UpdateIcon();
            sJs.printf(L"extentLayer(%d)", FLayerIdx);
            FRAMEOpenMap1->ExecScript(sJs);
            return;
        }

        if (AFunc.Pos("onfacilitydragend"))
        {
            TStringList *pStringList = new TStringList;
            pStringList->CommaText = AArgs;

            try
            {
                String sNmbr      = pStringList->Strings[0];
                String sCenterLat = pStringList->Strings[1];
                String sCenterLng = pStringList->Strings[2];
                SePosX->Value = sCenterLat.ToDouble();
                SePosY->Value = sCenterLng.ToDouble();
            }
            catch(Exception &e)
            {
            }
            delete pStringList;
        }
    }
    catch(Exception &exception)
    {
    }
}
//---------------------------------------------------------------------------

